package com.sagacloud.route.processors;

import org.apache.camel.Exchange;
import org.json.JSONObject;

import java.util.HashSet;
import java.util.Set;

/**
 * Created by wo on 9/4/18.
 */
public class ContractMethods {
    public static void preQueryEq(Exchange exchange) {
        exchange.getIn().setBody("{\"customInfo\":false,\"linkInfos\":false,\"criteria\":{\"type\":[\"Eq\"]}}");
    }

    public static void extractSupplierContractIds(Exchange exchange) {
        extract(exchange, "SupplierContractID");
    }

    public static void extractInsuranceNum(Exchange exchange) {
        extract(exchange, "InsuranceNum");
    }

    private static void extract(Exchange exchange, String info){
        String inStr = exchange.getIn().getBody(String.class);
        JSONObject json = new JSONObject(inStr);
        if(!json.getString("Result").equalsIgnoreCase("success")){
            return;
        }
        Set<String> contractIds = new HashSet<>();
        json.getJSONArray("Content").forEach(obj ->{
            JSONObject item = (JSONObject) obj;
            if(item.getJSONObject("infos").has(info)){
                contractIds.add(item.getJSONObject("infos").getString(info));
            }
        });
        JSONObject result = new JSONObject("{\"result\":\"success\",\"resultMsg\":\"\"}");
        result.put("content", contractIds);
        exchange.getOut().setBody(result);
    }
}
